using Infragistics.Win;
using System.Data;

namespace KB9240_WinFormsApp1
{
    public partial class Form1 : Form
    {
        private List<ValueListItem> _prefectures;

        public Form1()
        {
            InitializeComponent();

            _prefectures = new List<ValueListItem>()
            {
                new ValueListItem() { DataValue = 1, DisplayText = "kC"},
                new ValueListItem() { DataValue = 2, DisplayText = "X"},
                new ValueListItem() { DataValue = 3, DisplayText = "茧"},
                new ValueListItem() { DataValue = 4, DisplayText = "{錧"},
                new ValueListItem() { DataValue = 5, DisplayText = "Hc"},
                new ValueListItem() { DataValue = 6, DisplayText = "R`"},
                new ValueListItem() { DataValue = 7, DisplayText = ""},
                new ValueListItem() { DataValue = 8, DisplayText = "錧"},
                new ValueListItem() { DataValue = 9, DisplayText = "Ȗ،"},
                new ValueListItem() { DataValue = 10, DisplayText = "Qn"},
                new ValueListItem() { DataValue = 11, DisplayText = "ʌ"},
                new ValueListItem() { DataValue = 12, DisplayText = "t"},
                new ValueListItem() { DataValue = 13, DisplayText = "s"},
                new ValueListItem() { DataValue = 14, DisplayText = "_ސ쌧"},
                new ValueListItem() { DataValue = 15, DisplayText = "V"},
                new ValueListItem() { DataValue = 16, DisplayText = "xR"},
                new ValueListItem() { DataValue = 17, DisplayText = "ΐ쌧"},
                new ValueListItem() { DataValue = 18, DisplayText = "䌧"},
                new ValueListItem() { DataValue = 19, DisplayText = "R"},
                new ValueListItem() { DataValue = 20, DisplayText = "쌧"},
                new ValueListItem() { DataValue = 21, DisplayText = "򕌌"},
                new ValueListItem() { DataValue = 22, DisplayText = "É"},
                new ValueListItem() { DataValue = 23, DisplayText = "m"},
                new ValueListItem() { DataValue = 24, DisplayText = "Od"},
                new ValueListItem() { DataValue = 25, DisplayText = "ꌧ"},
                new ValueListItem() { DataValue = 26, DisplayText = "s{"},
                new ValueListItem() { DataValue = 27, DisplayText = "{"},
                new ValueListItem() { DataValue = 28, DisplayText = "Ɍ"},
                new ValueListItem() { DataValue = 29, DisplayText = "ޗǌ"},
                new ValueListItem() { DataValue = 30, DisplayText = "a̎R"},
                new ValueListItem() { DataValue = 31, DisplayText = "挧"},
                new ValueListItem() { DataValue = 32, DisplayText = ""},
                new ValueListItem() { DataValue = 33, DisplayText = "R"},
                new ValueListItem() { DataValue = 34, DisplayText = "L"},
                new ValueListItem() { DataValue = 35, DisplayText = "R"},
                new ValueListItem() { DataValue = 36, DisplayText = ""},
                new ValueListItem() { DataValue = 37, DisplayText = "쌧"},
                new ValueListItem() { DataValue = 38, DisplayText = "Q"},
                new ValueListItem() { DataValue = 39, DisplayText = "m"},
                new ValueListItem() { DataValue = 40, DisplayText = ""},
                new ValueListItem() { DataValue = 41, DisplayText = "ꌧ"},
                new ValueListItem() { DataValue = 42, DisplayText = "茧"},
                new ValueListItem() { DataValue = 43, DisplayText = "F{"},
                new ValueListItem() { DataValue = 44, DisplayText = "啪"},
                new ValueListItem() { DataValue = 45, DisplayText = "{茧"},
                new ValueListItem() { DataValue = 46, DisplayText = ""},
                new ValueListItem() { DataValue = 47, DisplayText = "ꌧ"},
            };
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = GetData();

            ValueList valueList = new ValueList();
            valueList.ValueListItems.AddRange(_prefectures.ToArray());
            ultraGrid1.DisplayLayout.Bands[0].Columns[2].ValueList = valueList;
        }

        private DataTable GetData()
        {
            Random rnd = new Random();
            String[] familyNames = new String[] { "yc", "c", "g", "c", "", "", "", "s", "c", "p", "", "ݓc", "J", "|", "ec", "n", "R", "啽", "c", "", "rJ", "", "", "׈", "", "", "", "c", "J", "", "D", "A", "Vq", "R", "q", "Fc", "", "c", "c", "ʏ", "ߓc", "c", "gc", "", "֒J", "", "c", "FJ", "", "I" };
            String[] givenNames = new string[] { "q", "", "э", "", "D", "", "", "O", "", "", "K", "F", "M", "M", "Ď", "ʔT", "ޏq", "", "PY", "CY", "M", "Fj", "", "猎", "", "Y", "Εv", "h", "qj", "딎", "", "F", "g", "P", "KY", "Y", "^", "ՔT", "Nj", "s", "t", "hY", "ʉ", "qb", "", "", "", "^", "", "^юq" };

            DataTable dt = new DataTable();

            // Columns
            DataColumn idColumn = dt.Columns.Add("ID", typeof(int));
            dt.Columns.Add("Name", typeof(String));
            dt.Columns.Add("Prefecture", typeof(String));
            dt.Columns.Add("Age", typeof(int));

            // Rows
            int rowCount = 10;
            for (int i = 0; i < rowCount; i++)
            {
                int familyNameIndex = rnd.Next(familyNames.Length);
                int givenNameIndex = rnd.Next(givenNames.Length);
                int prefecture = rnd.Next(_prefectures.Count);
                int age = rnd.Next(20, 80);
                dt.Rows.Add(new object[] { i, familyNames[familyNameIndex] + " " + givenNames[givenNameIndex], _prefectures[prefecture].DataValue, age });
            }

            // Primary key
            dt.PrimaryKey = new DataColumn[] { idColumn };

            return dt;
        }
    }
}